
implement Ack;

include "sys.m";	sys: Sys;
include "draw.m";	draw: Draw;
include "tk.m";		tk: Tk;
include	"wmlib.m";	wmlib: Wmlib;

Ack: module
{
        init:   fn(ctxt: ref Draw->Context, argv: list of string);
};

t: ref Tk->Toplevel;	# bad name for a global
N: int = 1000;			# instance size

init(ctxt: ref Draw->Context, argv: list of string)
{
	sys = load Sys Sys->PATH;
	draw = load Draw Draw->PATH;
	tk = load Tk Tk->PATH;
	wmlib = load Wmlib Wmlib->PATH;
	wmlib->init();

	tkargs := "";
	argv = tl argv;		# remove program name
	if (argv != nil) {	# and extract any -geom arg
		tkargs = hd argv;
		argv = tl argv;
	}
	 t = tk->toplevel(ctxt.screen, tkargs+" -borderwidth 2 -relief raised");
	#(t1, menubut) := wmlib->titlebar(ctxt.screen, "", "Text",
	#	 Wmlib->Hide|Wmlib->Resize);
	#t = t1;

	cmd := chan of string;
	tk->namechan(t, cmd, "cmd");

	tkcmd(t, "frame .f");
	tkcmd(t, "button .f.go -text {Ack} -command {send cmd Go}");
	tkcmd(t, "button .f.quit -text {Quit} -command {send cmd Quit}");
	tkcmd(t, "entry .f.n -width 5w");
	tkcmd(t, "entry .f.n2 -width 5w");
	tkcmd(t, "label .f.tim -text {time} -width 15");

	tkcmd(t, "pack .f.go .f.n .f.n2 .f.tim .f.quit -side left -fill x -expand 1");

	tkcmd(t, "text .t -height 24h -width 60w");
	tkcmd(t, "pack .f .t -side top -fill x");


	tkcmd(t, "update");

	for (;;) {
		alt {
		s := <- cmd =>
			(n, l) := sys->tokenize(s, " \t");
			case hd l {
			"Go" =>
				n1 := int tkcmd(t, ".f.n get");
				n2 := int tkcmd(t, ".f.n2 get");
				runack(n1, n2);
			"Quit" =>
				exit;
			}
		#menu := <-menubut =>
		#	wmlib->titlectl(t, menu);
		}
	}
}

runack(m, n: int)
{
	t0 := sys->millisec();
	a := ack(m, n);
	tkcmd(t, ".t insert end '" + string a + "  ");
	t1 := sys->millisec();
	tkcmd(t, ".t insert end '" + string m + ", " + string n + 
		" " + string (t1-t0) + "\n");
	tkcmd(t, "update");
}


# Do a tk->cmd, and catch errors.
tkcmd(top: ref Tk->Toplevel, cmd: string) : string
{
	e := tk->cmd(top, cmd);
	if(e != "" && e[0] == '!')
		sys->print("unexpected tk error executing %s: %s\n", cmd, e);
	return e;
}

ack(m, n: int) : int
{
        if (m == 0)
                return n+1;
        else if (n == 0)
                return ack(m-1, 1);
        else
                return ack(m-1, ack(m, n-1));
}
