# cat file...

implement Cat;

include "sys.m";
sys: Sys;
include "draw.m";
Context: import Draw;

Cat: module
{
	init:	fn(ctxt: ref Context, argv: list of string);
};

FD: import Sys;
stderr, stdout: ref FD;

init(nil: ref Context, argv: list of string)
{
	sys = load Sys "$Sys";

	stdout = sys->fildes(1);
	stderr = sys->fildes(2);
t0 := sys->millisec();
	argv = tl argv;
	if (argv == nil)
		argv = "-" :: nil;
	while (argv != nil) {
		cat(hd argv);
		argv = tl argv;
	}
t1 := sys->millisec();
	sys->fprint(stderr, "%d msec\n", t1-t0);
}

cat(file: string)
{
	n: int;
	fd: ref FD;
	buf := array[8192] of byte;

	if (file == "-")
		fd = sys->fildes(0);
	else {
		fd = sys->open(file, sys->OREAD);
		if (fd == nil) {
			sys->fprint(stderr, "cat: %s: %r\n", file);
			return;
		}
	}
	for (;;) {
		n = sys->read(fd, buf, len buf);
		if (n <= 0)
			break;
		if (sys->write(stdout, buf, n) < n) {
			sys->fprint(stderr, "cat: write error: %r\n");
			return;
		}
	}
	if (n < 0) {
		sys->fprint(stderr, "cat: read error: %r\n");
		return;
	}
}
