
implement Text;

include "sys.m";	sys: Sys;
include "draw.m";	draw: Draw;
include "tk.m";		tk: Tk;
include	"wmlib.m";	wmlib: Wmlib;

Text: module
{
        init:   fn(ctxt: ref Draw->Context, argv: list of string);
};

t: ref Tk->Toplevel;	# bad name for a global
N: int = 100;			# instance size

MINX: real = 30.0;
MAXX: real = 580.0;
MINY: real = 30.0;
MAXY: real = 380.0;

init(ctxt: ref Draw->Context, argv: list of string)
{
	sys = load Sys Sys->PATH;
	draw = load Draw Draw->PATH;
	tk = load Tk Tk->PATH;
	wmlib = load Wmlib Wmlib->PATH;
	wmlib->init();

	tkargs := "";
	argv = tl argv;		# remove program name
	if (argv != nil) {	# and extract any -geom arg
		tkargs = hd argv;
		argv = tl argv;
	}
	t = tk->toplevel(ctxt.screen, tkargs+" -borderwidth 2 -relief raised");
	#(t1, menubut) := wmlib->titlebar(ctxt.screen, "", "Text",
	#	 Wmlib->Hide|Wmlib->Resize);
	#t = t1;

	cmd := chan of string;
	tk->namechan(t, cmd, "cmd");

	tkcmd(t, "frame .f");
	tkcmd(t, "button .f.go -text {Go} -command {send cmd Go}");
	tkcmd(t, "button .f.quit -text {Quit} -command {send cmd Quit}");
	tkcmd(t, "entry .f.n");
	tkcmd(t, "label .f.tim -text {time} -width 15");

	tkcmd(t, "pack .f.go .f.n .f.tim .f.quit -side left -fill x -expand 1");

	tkcmd(t, "canvas .t -height 480 -width 640");
	tkcmd(t, "pack .f .t -side top -fill x");
	tkcmd(t, "update");

	for (;;) {
		alt {
		s := <- cmd =>
			(n, l) := sys->tokenize(s, " \t");
			case hd l {
			"Go" =>
				fill();
			"Quit" =>
				exit;
			}
		#menu := <-menubut =>
		#	wmlib->titlectl(t, menu);
		}
	}
}

fill()
{
	t0 := sys->millisec();
	tkcmd(t, ".t delete all; update");
	N = int tkcmd(t, ".f.n get");
	dx := (MAXX-MINX) / real N;
	dy := (MAXY-MINY) / real N;
	d := 4.0;
	s := "";
	for (i := 0; i < N; i++) {
		xi := real i;
		s = sys->sprint(".t create line %g %g %g %g -fill blue",
			MINX, MINY, MAXX, MINY + xi * dy);
		tkcmd(t, s);
		s = sys->sprint(".t create oval %g %g %g %g" +
			   " -fill red -outline black -width 2",
			MAXX, MINY + xi * dy, MAXX+d, MINY + xi * dy +d);
		tkcmd(t, s);
		# tkcmd(t, "update");
	}
	for (i = 0; i < N; i++) {
		xi := real i;
		s = sys->sprint(".t create line %g %g %g %g -fill blue",
			MINX, MINY, MINX + xi * dx, MAXY);
		tkcmd(t, s);
		s = sys->sprint(".t create oval %g %g %g %g" +
			   " -fill red -outline black -width 2",
			MINX + xi * dx, MAXY, MINX + xi * dx+d, MAXY+d);
		tkcmd(t, s);
		# tkcmd(t, "update");
	}
	t1 := sys->millisec();
	tkcmd(t, ".t create text 75 75 -fill white -anchor w -text '"+string (t1-t0));
	tkcmd(t, ".f.tim configure -text  '"+string (t1-t0));
	tkcmd(t, "update");
}

# Do a tk->cmd, and catch errors.
tkcmd(top: ref Tk->Toplevel, cmd: string) : string
{
	e := tk->cmd(top, cmd);
	if(e != "" && e[0] == '!')
		sys->print("unexpected tk error executing %s: %s\n", cmd, e);
	return e;
}
