
set MINX 30.0; set MAXX 580.0;
set MINY 30.0; set MAXY 380.0;
set n 100

proc draw {x y} {
	global MINX MINY
	set d 6
	.c create line $MINX $MINY $x $y -fill blue
	.c create oval $x $y [expr $x+$d] [expr $y+$d] -fill red
	# update
}

proc run {} {
	global n
	.c delete all
	update
	set tm [time dodraw]
	set tm [format "%.2f" [expr [lindex $tm 0]/1000000.0]]
	.c delete tm
	.c create text 10 10 -anchor w -text "$tm sec" -tags tm
	puts "$n  $tm sec"
}

proc dodraw {} {
	global n MINX MINY MAXX MAXY
	set dx [expr ($MAXX - $MINX) / $n]
	set dy [expr ($MAXY - $MINY) / $n]
	for {set i 1} {$i <= $n} {incr i} {
		draw $MAXX [expr $MINY + $i * $dy]
	}
	for {set i 1} {$i <= $n} {incr i} {
		draw [expr $MINX + $i * $dx] $MAXY
	}
}

proc init {} {
	global MAXY MAXX n
	frame .f
	label .f.n_lab -text "N:"
	entry .f.n_text -width 5 -textvariable n
	pack .f.n_lab .f.n_text -side left

	button .f.run -text "Run" -command run
	button .f.clear -text "Clear" -command ".c delete all"
	button .f.quit -text "Quit" -command "destroy ."
	pack .f.run .f.clear .f.quit -side left

	canvas .c -height [expr $MAXY+30] -width [expr $MAXX+30]
	pack .f 
	pack .c -side top -fill both -expand 1

	wm geometry . +100+50
}

init
