
implement Text;

include "sys.m";	sys: Sys;
include "draw.m";	draw: Draw;
include "tk.m";		tk: Tk;
include	"wmlib.m";	wmlib: Wmlib;

Text: module
{
        init:   fn(ctxt: ref Draw->Context, argv: list of string);
};

t: ref Tk->Toplevel;	# bad name for a global
N: int = 100;			# instance size

init(ctxt: ref Draw->Context, argv: list of string)
{
	sys = load Sys Sys->PATH;
	draw = load Draw Draw->PATH;
	tk = load Tk Tk->PATH;
	wmlib = load Wmlib Wmlib->PATH;
	wmlib->init();

	tkargs := "";
	argv = tl argv;		# remove program name
	if (argv != nil) {	# and extract any -geom arg
		tkargs = hd argv;
		argv = tl argv;
	}
	t = tk->toplevel(ctxt.screen, tkargs+" -borderwidth 2 -relief raised");
	#(t1, menubut) := wmlib->titlebar(ctxt.screen, "", "Text",
	#	 Wmlib->Hide|Wmlib->Resize);
	#t = t1;

	cmd := chan of string;
	tk->namechan(t, cmd, "cmd");

	tkcmd(t, "frame .f");
	tkcmd(t, "button .f.go -text {Go} -command {send cmd Go}");
	tkcmd(t, "button .f.quit -text {Quit} -command {send cmd Quit}");
	tkcmd(t, "entry .f.n");
	tkcmd(t, "label .f.tim -text {time} -width 5w");

	tkcmd(t, "pack .f.go .f.n .f.tim .f.quit -side left -fill x -expand 1");

	tkcmd(t, "text .t -height 24h -width 60w");
	tkcmd(t, "pack .f .t -side top -fill x");


	tkcmd(t, "update");
	lasterror("init");

	for (;;) {
		alt {
		s := <- cmd =>
			(n, l) := sys->tokenize(s, " \t");
			case hd l {
			"Go" =>
				fill();
			"Quit" =>
				exit;
			}
		#menu := <-menubut =>
		#	wmlib->titlectl(t, menu);
		}
	}
}

fill()
{
t0 := sys->millisec();
	tkcmd(t, ".t delete 1.0 end");
	N = int tkcmd(t, ".f.n get");
	for (i := 0; i < N; i++) {
		tk->cmd(t, ".t insert end " + string i + "\n");
		tk->cmd(t, ".t see end");
		tk->cmd(t, "update");
	}
t1 := sys->millisec();
	tkcmd(t, ".t insert end '"+string (t1-t0));
		tkcmd(t, "update");
}


lasterror(where: string)
{
	s := tkcmd(t, "variable lasterror");
	if (s != nil)
		sys->print("%s: tk error %s\n", where, s);
}

# Do a tk->cmd, and catch errors.
tkcmd(top: ref Tk->Toplevel, cmd: string) : string
{
	e := tk->cmd(top, cmd);
	if(e != "" && e[0] == '!')
		sys->print("unexpected tk error executing %s: %s\n", cmd, e);
	return e;
}

rf(path: string) : string
{
	fd := sys->open(path, sys->OREAD);
	if(fd == nil)
		return "Anon";

	buf := array[512] of byte;
	n := sys->read(fd, buf, len buf);
	if(n <= 0)
		return "Anon";

	return string buf[0:n];
}
