implement Wc;

# wc <input
# supposedly this does buffered input

include "sys.m";
	sys: Sys;
include "draw.m";

Wc: module
{
	init:	fn(ctxt: ref Draw->Context, argv: list of string);
};

include "bufio.m";
	bufmod: Bufio;
Iobuf:	import bufmod;
	iob:	ref Iobuf;

init(nil: ref Draw->Context, nil: list of string)
{
	sys = load Sys Sys->PATH;
	bufmod = load Bufio Bufio->PATH;
	if (bufmod == nil) {
		sys->print("bufmod load: %r\n");
		exit;
	}

	stdin := sys->fildes(0);
	iob = bufmod->fopen(stdin, bufmod->OREAD);
	if (iob == nil) {
		sys->print("iob open: %r\n");
		exit;
	}

	OUT: con 0;
	IN: con 1;
t0 := sys->millisec();

	state := OUT;
	nl := 0; nw := 0; nc := 0;
	for (;;) {
		c := iob.getc();
		if (c == bufmod->EOF)
			break;
		nc++;
		if (c == '\n')
			nl++;
		if (c == ' ' || c == '\t' || c == '\n')
			state = OUT;
		else if (state == OUT) {
			state = IN;
			nw++;
		}
	}
t1 := sys->millisec();
	sys->print("%d %d %d    %d\n", nl, nw, nc, t1-t0);
}
